Liferay.Loader.define("frontend-taglib-clay@6.6.9/data_set_display/utilities/iframes", ['module', 'exports', 'require', './eventsDefinitions'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.getIframeHandlerModalId = getIframeHandlerModalId;
    exports.isPageInIframe = isPageInIframe;
    exports.initializeIframeListeners = initializeIframeListeners;
    exports.iframeInitialHandlerModalId = exports.counter = exports.iframeHandlerModalNamespace = void 0;

    var _eventsDefinitions = require("./eventsDefinitions");

    function ownKeys(object, enumerableOnly) {
      var keys = Object.keys(object);if (Object.getOwnPropertySymbols) {
        var symbols = Object.getOwnPropertySymbols(object);if (enumerableOnly) symbols = symbols.filter(function (sym) {
          return Object.getOwnPropertyDescriptor(object, sym).enumerable;
        });keys.push.apply(keys, symbols);
      }return keys;
    }

    function _objectSpread(target) {
      for (var i = 1; i < arguments.length; i++) {
        var source = arguments[i] != null ? arguments[i] : {};if (i % 2) {
          ownKeys(Object(source), true).forEach(function (key) {
            _defineProperty(target, key, source[key]);
          });
        } else if (Object.getOwnPropertyDescriptors) {
          Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
        } else {
          ownKeys(Object(source)).forEach(function (key) {
            Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
          });
        }
      }return target;
    }

    function _defineProperty(obj, key, value) {
      if (key in obj) {
        Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true });
      } else {
        obj[key] = value;
      }return obj;
    }

    var iframeHandlerModalNamespace = 'iframe-handler-modal_';
    exports.iframeHandlerModalNamespace = iframeHandlerModalNamespace;
    var counter = 0;
    exports.counter = counter;
    var iframeInitialHandlerModalId = "".concat(iframeHandlerModalNamespace).concat(counter);
    exports.iframeInitialHandlerModalId = iframeInitialHandlerModalId;
    Liferay.on('endNavigate', function () {
      exports.counter = counter = 0;
    });

    function getIframeHandlerModalId() {
      var _counter;

      return "".concat(iframeHandlerModalNamespace).concat((_counter = +counter, exports.counter = counter = _counter + 1, _counter));
    }

    function isPageInIframe() {
      return window.location !== window.parent.location;
    }

    function initializeIframeListeners() {
      Liferay.on(_eventsDefinitions.OPEN_MODAL, function (payload) {
        window.top.Liferay.fire(_eventsDefinitions.OPEN_MODAL, _objectSpread(_objectSpread({}, payload), {}, {
          id: iframeInitialHandlerModalId
        }));
      });
    }
    //# sourceMappingURL=iframes.js.map
  }
});
//# sourceMappingURL=iframes.js.map