<%--
/**
 * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of the Liferay Enterprise
 * Subscription License ("License"). You may not use this file except in
 * compliance with the License. You can obtain a copy of the License by
 * contacting Liferay, Inc. See the License for the specific language governing
 * permissions and limitations under the License, including but not limited to
 * distribution rights of the Software.
 *
 *
 *
 */
--%>

<%@ include file="/init.jsp" %>

<%
CommerceAccountOrganizationRelAdminDisplayContext commerceAccountOrganizationRelAdminDisplayContext = (CommerceAccountOrganizationRelAdminDisplayContext)request.getAttribute(WebKeys.PORTLET_DISPLAY_CONTEXT);

ResultRow row = (ResultRow)request.getAttribute(WebKeys.SEARCH_CONTAINER_RESULT_ROW);

CommerceAccountOrganizationRel commerceAccountOrganizationRel = (CommerceAccountOrganizationRel)row.getObject();
%>

<liferay-ui:icon-menu
	direction="left-side"
	icon="<%= StringPool.BLANK %>"
	markupView="lexicon"
	message="<%= StringPool.BLANK %>"
	showWhenSingleIcon="<%= true %>"
>
	<c:if test="<%= commerceAccountOrganizationRelAdminDisplayContext.hasPermission(commerceAccountOrganizationRel.getCommerceAccountId(), ActionKeys.UPDATE) %>">
		<liferay-ui:icon
			message="edit"
			url="<%= commerceAccountOrganizationRelAdminDisplayContext.getEditOrganizationURL(commerceAccountOrganizationRel.getOrganizationId()) %>"
		/>
	</c:if>

	<c:if test="<%= commerceAccountOrganizationRelAdminDisplayContext.hasPermission(commerceAccountOrganizationRel.getCommerceAccountId(), ActionKeys.DELETE) %>">
		<portlet:actionURL name="/commerce_account_admin/edit_commerce_account_organization_rel" var="deleteURL">
			<portlet:param name="<%= Constants.CMD %>" value="<%= Constants.DELETE %>" />
			<portlet:param name="redirect" value="<%= currentURL %>" />
			<portlet:param name="commerceAccountId" value="<%= String.valueOf(commerceAccountOrganizationRel.getCommerceAccountId()) %>" />
			<portlet:param name="organizationId" value="<%= String.valueOf(commerceAccountOrganizationRel.getOrganizationId()) %>" />
		</portlet:actionURL>

		<liferay-ui:icon-delete
			message="remove"
			url="<%= deleteURL %>"
		/>
	</c:if>
</liferay-ui:icon-menu>