Liferay.Loader.define("commerce-product-options-web@3.0.21/CPOptionValueDetail.es", ['module', 'exports', 'require', 'frontend-js-web', 'frontend-js-metal-web$metal-component', 'frontend-js-metal-web$metal-dom', 'frontend-js-metal-web$metal-soy', 'frontend-js-metal-web$metal-state', './CPOptionValueDetail.soy'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = void 0;

    var _frontendJsWeb = require("frontend-js-web");

    var _metalComponent = _interopRequireDefault(require("frontend-js-metal-web$metal-component"));

    var _metalDom = require("frontend-js-metal-web$metal-dom");

    var _metalSoy = _interopRequireDefault(require("frontend-js-metal-web$metal-soy"));

    var _metalState = require("frontend-js-metal-web$metal-state");

    var _CPOptionValueDetail = _interopRequireDefault(require("./CPOptionValueDetail.soy"));

    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }

    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof(obj) {
          return typeof obj;
        };
      } else {
        _typeof = function _typeof(obj) {
          return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
        };
      }return _typeof(obj);
    }

    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }

    function _defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ("value" in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);
      }
    }

    function _createClass(Constructor, protoProps, staticProps) {
      if (protoProps) _defineProperties(Constructor.prototype, protoProps);if (staticProps) _defineProperties(Constructor, staticProps);return Constructor;
    }

    function _possibleConstructorReturn(self, call) {
      if (call && (_typeof(call) === "object" || typeof call === "function")) {
        return call;
      }return _assertThisInitialized(self);
    }

    function _assertThisInitialized(self) {
      if (self === void 0) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
      }return self;
    }

    function _getPrototypeOf(o) {
      _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
        return o.__proto__ || Object.getPrototypeOf(o);
      };return _getPrototypeOf(o);
    }

    function _inherits(subClass, superClass) {
      if (typeof superClass !== "function" && superClass !== null) {
        throw new TypeError("Super expression must either be null or a function");
      }subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });if (superClass) _setPrototypeOf(subClass, superClass);
    }

    function _setPrototypeOf(o, p) {
      _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
        o.__proto__ = p;return o;
      };return _setPrototypeOf(o, p);
    }

    /**
     * CPOptionValueDetail
     *
     */
    var CPOptionValueDetail = /*#__PURE__*/function (_Component) {
      _inherits(CPOptionValueDetail, _Component);

      function CPOptionValueDetail(opt_config, opt_parentElement) {
        var _this;

        _classCallCheck(this, CPOptionValueDetail);

        _this = _possibleConstructorReturn(this, _getPrototypeOf(CPOptionValueDetail).call(this, opt_config, opt_parentElement));

        _this.on('cpOptionValueIdChanged', _this._handleCPOptionValueChange);

        return _this;
      }

      _createClass(CPOptionValueDetail, [{
        key: "rendered",
        value: function rendered() {
          this.loadOptionValueDetail(this.cpOptionValueId);
        }
      }, {
        key: "loadOptionValueDetail",
        value: function loadOptionValueDetail(cpOptionValueId) {
          var instance = this;
          var optionValueDetail = this.element.querySelector('.option-value-detail');
          var url = new URL(this.optionValueURL);
          url.searchParams.append(this.namespace + 'cpOptionValueId', cpOptionValueId);
          (0, _frontendJsWeb.fetch)(url).then(function (response) {
            return response.text();
          }).then(function (text) {
            optionValueDetail.innerHTML = text;

            _metalDom.globalEval.runScriptsInElement(optionValueDetail);

            var name = optionValueDetail.querySelector('#' + instance.namespace + 'optionValueName');

            if (name) {
              name.addEventListener('keyup', function (event) {
                var target = event.target;
                instance.emit('nameChange', target.value);
              });
            }
          });
        }
      }, {
        key: "_handleCPOptionValueChange",
        value: function _handleCPOptionValueChange(event) {
          this.loadOptionValueDetail(event.newVal);
        }
      }, {
        key: "_handleSaveOptionValue",
        value: function _handleSaveOptionValue() {
          var instance = this;
          AUI().use('aui-base', 'aui-form-validator', 'liferay-form', function (A) {
            var hasErrors = false;
            var form = instance.element.querySelector('.option-value-detail form');
            var liferayForm = Liferay.Form.get(form.getAttribute('id'));

            if (liferayForm) {
              var validator = liferayForm.formValidator;

              if (A.instanceOf(validator, A.FormValidator)) {
                validator.validate();
                hasErrors = validator.hasErrors();

                if (hasErrors) {
                  validator.focusInvalidField();
                }
              }
            }

            if (!hasErrors) {
              instance._saveOptionValue();
            }
          });
        }
      }, {
        key: "_handleCancel",
        value: function _handleCancel() {
          this.emit('cancel');
        }
      }, {
        key: "_handleDeleteOptionValue",
        value: function _handleDeleteOptionValue() {
          if (confirm(Liferay.Language.get('are-you-sure-you-want-to-delete-this'))) {
            this._deleteOptionValue();
          }
        }
      }, {
        key: "_deleteOptionValue",
        value: function _deleteOptionValue() {
          var _this2 = this;

          var form = this.element.querySelector('.option-value-detail form');
          form.querySelector('[name=' + this.namespace + 'cmd]').value = 'delete';
          var formData = new FormData(form);
          (0, _frontendJsWeb.fetch)(form.action, {
            body: formData,
            method: 'POST'
          }).then(function (response) {
            return response.json();
          }).then(function (jsonResponse) {
            _this2.emit('optionValueDeleted', jsonResponse);
          });
        }
      }, {
        key: "_saveOptionValue",
        value: function _saveOptionValue() {
          var _this3 = this;

          var form = this.element.querySelector('.option-value-detail form');
          form.querySelector('[name=' + this.namespace + 'cpOptionId]').value = this.cpOptionId;
          var formData = new FormData(form);
          (0, _frontendJsWeb.fetch)(form.action, {
            body: formData,
            method: 'POST'
          }).then(function (response) {
            return response.json();
          }).then(function (jsonResponse) {
            _this3.emit('optionValueSaved', jsonResponse);
          });
        }
      }]);

      return CPOptionValueDetail;
    }(_metalComponent.default);
    /**
     * State definition.
     * @type {!Object}
     * @static
     */

    CPOptionValueDetail.STATE = {
      cpOptionId: _metalState.Config.string().required(),
      cpOptionValueId: _metalState.Config.string().required(),
      namespace: _metalState.Config.string().required(),
      optionValueURL: _metalState.Config.string().required(),
      pathThemeImages: _metalState.Config.string().required()
    }; // Register component

    _metalSoy.default.register(CPOptionValueDetail, _CPOptionValueDetail.default);

    var _default = CPOptionValueDetail;
    exports.default = _default;
    //# sourceMappingURL=CPOptionValueDetail.es.js.map
  }
});
//# sourceMappingURL=CPOptionValueDetail.es.js.map