Liferay.Loader.define("commerce-product-options-web@3.0.21/CPOptionValueList.es", ['module', 'exports', 'require', 'frontend-js-metal-web$metal-component', 'frontend-js-metal-web$metal-dom', 'frontend-js-metal-web$metal-soy', 'frontend-js-metal-web$metal-state', './CPOptionValueList.soy'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = void 0;

    var _metalComponent = _interopRequireDefault(require("frontend-js-metal-web$metal-component"));

    var _metalDom = _interopRequireDefault(require("frontend-js-metal-web$metal-dom"));

    var _metalSoy = _interopRequireDefault(require("frontend-js-metal-web$metal-soy"));

    var _metalState = require("frontend-js-metal-web$metal-state");

    var _CPOptionValueList = _interopRequireDefault(require("./CPOptionValueList.soy"));

    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }

    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof(obj) {
          return typeof obj;
        };
      } else {
        _typeof = function _typeof(obj) {
          return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
        };
      }return _typeof(obj);
    }

    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }

    function _defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ("value" in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);
      }
    }

    function _createClass(Constructor, protoProps, staticProps) {
      if (protoProps) _defineProperties(Constructor.prototype, protoProps);if (staticProps) _defineProperties(Constructor, staticProps);return Constructor;
    }

    function _possibleConstructorReturn(self, call) {
      if (call && (_typeof(call) === "object" || typeof call === "function")) {
        return call;
      }return _assertThisInitialized(self);
    }

    function _assertThisInitialized(self) {
      if (self === void 0) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
      }return self;
    }

    function _getPrototypeOf(o) {
      _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
        return o.__proto__ || Object.getPrototypeOf(o);
      };return _getPrototypeOf(o);
    }

    function _inherits(subClass, superClass) {
      if (typeof superClass !== "function" && superClass !== null) {
        throw new TypeError("Super expression must either be null or a function");
      }subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });if (superClass) _setPrototypeOf(subClass, superClass);
    }

    function _setPrototypeOf(o, p) {
      _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
        o.__proto__ = p;return o;
      };return _setPrototypeOf(o, p);
    }

    /**
     * CPOptionValueList
     *
     */
    var CPOptionValueList = /*#__PURE__*/function (_Component) {
      _inherits(CPOptionValueList, _Component);

      function CPOptionValueList() {
        _classCallCheck(this, CPOptionValueList);

        return _possibleConstructorReturn(this, _getPrototypeOf(CPOptionValueList).apply(this, arguments));
      }

      _createClass(CPOptionValueList, [{
        key: "_handleAddOptionValueClick",
        value: function _handleAddOptionValueClick(event) {
          event.stopImmediatePropagation();
          event.preventDefault();
          this.emit('addOptionValue');
        }
      }, {
        key: "_handleSelectOptionValueClick",
        value: function _handleSelectOptionValueClick(event) {
          var target = event.target;

          var row = _metalDom.default.closest(target, 'tr');

          var cpOptionValueId = row.getAttribute('data-id');
          this.emit('optionValueSelected', cpOptionValueId);
        }
      }]);

      return CPOptionValueList;
    }(_metalComponent.default);
    /**
     * State definition.
     * @type {!Object}
     * @static
     */

    CPOptionValueList.STATE = {
      currentCPOptionValueId: _metalState.Config.string(),
      optionValues: _metalState.Config.array().value([])
    }; // Register component

    _metalSoy.default.register(CPOptionValueList, _CPOptionValueList.default);

    var _default = CPOptionValueList;
    exports.default = _default;
    //# sourceMappingURL=CPOptionValueList.es.js.map
  }
});
//# sourceMappingURL=CPOptionValueList.es.js.map