Liferay.Loader.define("frontend-taglib-clay@6.6.9/DropdownMenu", ['module', 'exports', 'require', '@frontend-taglib-clay$clayui/button', '@frontend-taglib-clay$clayui/drop-down', '@frontend-taglib-clay$clayui/icon', '@frontend-taglib-clay$clayui/link', 'frontend-taglib-clay$classnames', 'frontend-js-react-web$react'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof(obj) {
          return typeof obj;
        };
      } else {
        _typeof = function _typeof(obj) {
          return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
        };
      }return _typeof(obj);
    }

    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = DropdownMenu;

    var _button = _interopRequireWildcard(require("@frontend-taglib-clay$clayui/button"));

    var _dropDown = require("@frontend-taglib-clay$clayui/drop-down");

    var _icon = _interopRequireDefault(require("@frontend-taglib-clay$clayui/icon"));

    var _link = _interopRequireDefault(require("@frontend-taglib-clay$clayui/link"));

    var _classnames = _interopRequireDefault(require("frontend-taglib-clay$classnames"));

    var _react = _interopRequireDefault(require("frontend-js-react-web$react"));

    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }

    function _getRequireWildcardCache() {
      if (typeof WeakMap !== "function") return null;var cache = new WeakMap();_getRequireWildcardCache = function _getRequireWildcardCache() {
        return cache;
      };return cache;
    }

    function _interopRequireWildcard(obj) {
      if (obj && obj.__esModule) {
        return obj;
      }if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") {
        return { default: obj };
      }var cache = _getRequireWildcardCache();if (cache && cache.has(obj)) {
        return cache.get(obj);
      }var newObj = {};var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;for (var key in obj) {
        if (Object.prototype.hasOwnProperty.call(obj, key)) {
          var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;if (desc && (desc.get || desc.set)) {
            Object.defineProperty(newObj, key, desc);
          } else {
            newObj[key] = obj[key];
          }
        }
      }newObj.default = obj;if (cache) {
        cache.set(obj, newObj);
      }return newObj;
    }

    function _extends() {
      _extends = Object.assign || function (target) {
        for (var i = 1; i < arguments.length; i++) {
          var source = arguments[i];for (var key in source) {
            if (Object.prototype.hasOwnProperty.call(source, key)) {
              target[key] = source[key];
            }
          }
        }return target;
      };return _extends.apply(this, arguments);
    }

    function ownKeys(object, enumerableOnly) {
      var keys = Object.keys(object);if (Object.getOwnPropertySymbols) {
        var symbols = Object.getOwnPropertySymbols(object);if (enumerableOnly) symbols = symbols.filter(function (sym) {
          return Object.getOwnPropertyDescriptor(object, sym).enumerable;
        });keys.push.apply(keys, symbols);
      }return keys;
    }

    function _objectSpread(target) {
      for (var i = 1; i < arguments.length; i++) {
        var source = arguments[i] != null ? arguments[i] : {};if (i % 2) {
          ownKeys(Object(source), true).forEach(function (key) {
            _defineProperty(target, key, source[key]);
          });
        } else if (Object.getOwnPropertyDescriptors) {
          Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
        } else {
          ownKeys(Object(source)).forEach(function (key) {
            Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
          });
        }
      }return target;
    }

    function _defineProperty(obj, key, value) {
      if (key in obj) {
        Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true });
      } else {
        obj[key] = value;
      }return obj;
    }

    function _slicedToArray(arr, i) {
      return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
    }

    function _nonIterableRest() {
      throw new TypeError("Invalid attempt to destructure non-iterable instance");
    }

    function _iterableToArrayLimit(arr, i) {
      if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) {
        return;
      }var _arr = [];var _n = true;var _d = false;var _e = undefined;try {
        for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
          _arr.push(_s.value);if (i && _arr.length === i) break;
        }
      } catch (err) {
        _d = true;_e = err;
      } finally {
        try {
          if (!_n && _i["return"] != null) _i["return"]();
        } finally {
          if (_d) throw _e;
        }
      }return _arr;
    }

    function _arrayWithHoles(arr) {
      if (Array.isArray(arr)) return arr;
    }

    function _objectWithoutProperties(source, excluded) {
      if (source == null) return {};var target = _objectWithoutPropertiesLoose(source, excluded);var key, i;if (Object.getOwnPropertySymbols) {
        var sourceSymbolKeys = Object.getOwnPropertySymbols(source);for (i = 0; i < sourceSymbolKeys.length; i++) {
          key = sourceSymbolKeys[i];if (excluded.indexOf(key) >= 0) continue;if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;target[key] = source[key];
        }
      }return target;
    }

    function _objectWithoutPropertiesLoose(source, excluded) {
      if (source == null) return {};var target = {};var sourceKeys = Object.keys(source);var key, i;for (i = 0; i < sourceKeys.length; i++) {
        key = sourceKeys[i];if (excluded.indexOf(key) >= 0) continue;target[key] = source[key];
      }return target;
    }

    function DropdownMenu(_ref) {
      var _ref$actionsDropdown = _ref.actionsDropdown,
          actionsDropdown = _ref$actionsDropdown === void 0 ? false : _ref$actionsDropdown,
          _additionalProps = _ref.additionalProps,
          _componentId = _ref.componentId,
          cssClass = _ref.cssClass,
          icon = _ref.icon,
          items = _ref.items,
          label = _ref.label,
          _locale = _ref.locale,
          _portletId = _ref.portletId,
          _portletNamespace = _ref.portletNamespace,
          otherProps = _objectWithoutProperties(_ref, ["actionsDropdown", "additionalProps", "componentId", "cssClass", "icon", "items", "label", "locale", "portletId", "portletNamespace"]);

      return (/*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_dropDown.ClayDropDownWithItems, {
          className: (0, _classnames.default)({
            'dropdown-action': actionsDropdown
          }),
          items: items.map(function (_ref2) {
            var data = _ref2.data,
                rest = _objectWithoutProperties(_ref2, ["data"]);

            var dataAttributes = data ? Object.entries(data).reduce(function (acc, _ref3) {
              var _ref4 = _slicedToArray(_ref3, 2),
                  key = _ref4[0],
                  value = _ref4[1];

              acc["data-".concat(key)] = value;
              return acc;
            }, {}) : {};
            return _objectSpread(_objectSpread({}, dataAttributes), rest);
          }),
          trigger: /*#__PURE__*/_react.default.createElement(_button.default, _extends({
            className: (0, _classnames.default)(cssClass, {
              'component-action': actionsDropdown
            })
          }, otherProps), icon && /*#__PURE__*/_react.default.createElement("span", {
            className: (0, _classnames.default)('inline-item', {
              'inline-item-before': label
            })
          }, /*#__PURE__*/_react.default.createElement(_icon.default, {
            symbol: icon
          })), label)
        }), /*#__PURE__*/_react.default.createElement("div", {
          className: "quick-action-menu"
        }, items.map(function (_ref5) {
          var data = _ref5.data,
              href = _ref5.href,
              icon = _ref5.icon,
              quickAction = _ref5.quickAction,
              rest = _objectWithoutProperties(_ref5, ["data", "href", "icon", "quickAction"]);

          return (data === null || data === void 0 ? void 0 : data.action) && quickAction ? /*#__PURE__*/_react.default.createElement(_button.ClayButtonWithIcon, _extends({
            className: "component-action quick-action-item",
            displayType: "unstyled",
            small: true,
            symbol: icon
          }, rest)) : href && icon && quickAction && /*#__PURE__*/_react.default.createElement(_link.default, _extends({
            className: "component-action quick-action-item",
            href: href
          }, rest), /*#__PURE__*/_react.default.createElement(_icon.default, {
            symbol: icon
          }));
        })))
      );
    }
    //# sourceMappingURL=DropdownMenu.js.map
  }
});
//# sourceMappingURL=DropdownMenu.js.map