Liferay.Loader.define("frontend-taglib-clay@6.6.9/data_set_display/thunks/persistVisibleFieldNames", ['module', 'exports', 'require', '../actions/updateVisibleFieldNames', '../utilities/saveViewSettings'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = persistVisibleFieldNames;

    var _updateVisibleFieldNames = require("../actions/updateVisibleFieldNames");

    var _saveViewSettings = require("../utilities/saveViewSettings");

    /**
     * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
     *
     * This library is free software; you can redistribute it and/or modify it under
     * the terms of the GNU Lesser General Public License as published by the Free
     * Software Foundation; either version 2.1 of the License, or (at your option)
     * any later version.
     *
     * This library is distributed in the hope that it will be useful, but WITHOUT
     * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
     * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
     * details.
     */
    function persistVisibleFieldNames(_ref) {
      var appURL = _ref.appURL,
          id = _ref.id,
          portletId = _ref.portletId,
          visibleFieldNames = _ref.visibleFieldNames;
      return function (dispatch) {
        dispatch((0, _updateVisibleFieldNames.updateVisibleFieldNames)(visibleFieldNames));
        return (0, _saveViewSettings.saveViewSettings)({
          appURL: appURL,
          id: id,
          portletId: portletId,
          settings: {
            visibleFieldNames: visibleFieldNames
          }
        });
      };
    }
    //# sourceMappingURL=persistVisibleFieldNames.js.map
  }
});
//# sourceMappingURL=persistVisibleFieldNames.js.map